let angle = 0;

function setup() {
    createCanvas(600, 600);
    angleMode(DEGREES);  // Use degrees for rotation
    noStroke();  // No stroke for shapes
    fill(0, 15, 30, 220);  // Color fill for ellipses
}

function draw() {
    background(255);  // White background

    translate(width / 2, height / 2);  // Move the origin to the center of the canvas

    // Outer for loop to create multiple rows of rotating ellipses
    for (let a = 0; a < 360; a += 22.5) {
        rotate(a);  // Rotate each set of ellipses around the center

        push();  // Save the current transformation state
        for (let i = 0; i < 100; i++) {
            scale(0.95);  // Gradually shrink the ellipses
            rotate(angle);  // Rotate each ellipse individually
            ellipse(150, 0, 50, 50);  // Draw ellipses at a fixed distance from the center
        }
        pop();  // Restore the transformation state

        push();  // Create another set of rotating ellipses in the opposite direction
        for (let i = 0; i < 100; i++) {
            scale(0.95);  // Gradually shrink the ellipses
            rotate(-angle);  // Rotate in the opposite direction
            ellipse(150, 0, 50, 50);  // Draw ellipses at a fixed distance from the center
        }
        pop();  // Restore the transformation state
    }

    angle += 0.01;  // Increase the rotation angle for the next frame
}
